% Usage: imwavefull(x, levels, filt).
% Recursive application of imwave1.m, for full wavelet transform.  
% Applies one stage transform "levels" times in both directions.
function c = imwavefull(x, levels, filt)

[m,n]=size(x);

q = m; p = n;
c = x;

for j=1:levels
    c(1:q,1:p) = imwave1(c(1:q,1:p),filt);
    q = q/2; p = p/2;
end
